/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package backup;

import java.io.File;

/**
 * @author  Georg Dietrich
 * @version 1.0 on 2004-04-10
 */
public class DataCheck implements ObjectHandler {

	Settings settings;
	
	public DataCheck (Settings mySettings) {
		settings = mySettings;
	}

	public boolean perform(Object object) {
		File data = (File) object;
		// leave untouched all non-.txt files
		if (!Util.canonicalPath(data).endsWith(".txt")) { return true; }
		File source = Util.data2source(data, settings);
		// if source file exists, return
		if (source.exists()) return true;
		// get data file entry
		DataFile dataFile = new DataFile(data);
		// if deletion is already logged, return
		if (dataFile.all.get(0).equals("missing")) { return true; }
		// update data file entry
		dataFile.all.add(0, settings.timeStamp);
		dataFile.all.add(0, "missing");
		// log changes
		settings.log.log("marked orphan data file "+data, 2);
		return true;
	}

}
