/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package backup;

/**
 * Simple interface that allows effectively to pass a method
 * as an argument in the guise of a class.  The interface is
 * used in cases like perusing the same list with different
 * methods.
 * 
 * @author  Georg Ohler 
 * @version 1.0 on 2002-12-29
 */

public interface ObjectHandler {
	/**
	 * the operation to be performed on an object
	 * 
	 * @param  object  the object to work on
	 */
	public boolean perform(Object object);
}
