/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package ui;

import java.util.Arrays;
import java.util.Vector;

/**
 * the values needed for localization of the program.
 * 
 * @author  Georg Dietrich
 * @version 1.0 on 2004-04-18
 */
public class Local {
	
	/** TODO: check */
	public static final String AUTOSTART_IND = "start";

	/** string indicating that the default value is to be used TODO: remove */
	public static final String DEFAULT_IND = "_";

	/** string indicating that the default value is to be used */
	public static final String SWITCH_IND = "-";

	/** log file file name */
	public static final String LOGFILE = "jabak.log";

	/** the strings used for indicating that source path is following */
	public static final String[] SOURCE_SWITCH = {"source", "s"};

	/** the strings used for indicating that destination path is following */
	public static final String[] DEST_SWITCH = {"dest", "d", "destination"};

	/** the strings used for indicating that data path is following */
	public static final String[] DATA_SWITCH = {"data", "D"};

	/** the strings used for indicating that the backup size is following */
	public static final String[] SIZE_SWITCH = {"size", "S"};

	/** the strings used for indicating that the backup type is following */
	public static final String[] TYPE_SWITCH = {"type", "t"};

	/** the strings used for indicating that the backup filter is following */
	public static final String[] FILTER_SWITCH = {"filter", "f"};

	/** the strings used for indicating that the zip filter/mode is following */
	public static final String[] ZIP_SWITCH = {"zip", "z"};

	/** the strings used for indicating that no config file should be used */
	public static final String[] NOCONFFILE_SWITCH = {"nodefaultconfigfile", "n"};

	/** the strings used for indicating that the config file path is following */
	public static final String[] CONFFILE_SWITCH = {"configfile", "c"};

	/** the strings used for indicating that no GUI will be constructed */
	public static final String[] NOGUI_SWITCH = {"nogui", "N"};

	/** the strings used for indicating backup should start immediately */
	public static final String[] IMMEDIATE_SWITCH = {"immediate", "i"};

	/** the strings used for indicating backup should start immediately */
	public static final String[] HASH_SWITCH = {"hash", "H"};

	/** the strings used for indicating backup should start immediately */
	public static final String[] HELP_SWITCH = {"help", "h"};

	/** the strings used for indicating backup should start immediately */
	public static final String[] LONGHELP_SWITCH = {"longhelp", "l"};

	/** the strings used for indicating backup should start immediately */
	public static final String[] VERSION_SWITCH = {"version", "v"};
	
	/** the strings used for indicating the comparision to use is following */
	public static final String[] COMP_SWITCH = {"compare", "C"};

	/**
	 * the names of the four backup types plus the default choose value
	 * as they will appear in the GUI dropdown chooser
	 */
	public static final String[] DROPLIST_TYPES = {"    Choose backup type",
		"    Incremental","    Differential 2 Diff",
		"    Differential 2 Full","    Full"};

	/**
	 * the names of the four backup types plus the default choose value
	 * as they are used in command line and config file switches.  Don't
	 * use names with spaces!
	 */
	public static final String[] BACKUP_TYPE_NAME = {"choose", "incremental", "diff2diff", "diff2full", "full"};

	/** a vector of the backup type names */
	public static final Vector BACKUP_TYPES = new Vector(Arrays.asList(BACKUP_TYPE_NAME));

	/**
	 * the names of the three comparision modes as used in command line,
	 * config file, and GUI dropdown list
	 */
	public static final String[] COMP_TYPE_NAMES = {"choose", "date", "hash", "both"};

	/** vector of the comparision type names */
	public static final Vector COMP_TYPES = new Vector(Arrays.asList(COMP_TYPE_NAMES));

	/** the version string of the jabak application */
	public static final String VERSION = "0.9";

	/** the text to display for the -version switch */
	public static final String VERSION_DISCLAIMER = 
		"jabak "+VERSION+"\n\n"+
		"This program is free software; you can redistribute it and/or modify it\n"+
		"under the terms of the GNU General Public License as published by the\n"+
		"Free Software Foundation; either version 2 of the License, or (at your\n"+
		"option) any later version.\n\n"+
		"This program is distributed in the hope that it will be useful, but\n"+
		"WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n"+
		"or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License\n"+
		"for more details.\n";


	/** a string displayed on command line as short help text */
	public static final String SHORT_HELP =
		"jabak "+VERSION+" short help\n\n"+
		"This program is free software; you can redistribute it and/or modify it\n"+
		"under the terms of the GNU General Public License as published by the\n"+
		"Free Software Foundation; either version 2 of the License, or (at your\n"+
		"option) any later version.\n\n"+
		"This program is distributed in the hope that it will be useful, but\n"+
		"WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n"+
		"or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License\n"+
		"for more details.\n\n"+
		"all jabak command line switches ar optional.\n"+
		"supported switches '"+SWITCH_IND+"switch' are:\n"+
		"-"+CONFFILE_SWITCH[0]+" [user configuration file]\n"+
		"-"+DATA_SWITCH[0]+" [custom data directory]\n"+
		"-"+DEST_SWITCH[0]+" [custom destination directory]\n"+
		"-"+FILTER_SWITCH[0]+" [backup file filters]\n"+
		"-"+HASH_SWITCH[0]+" to enforce using hash sums\n"+
		"-"+HELP_SWITCH[0]+" for this help text\n"+
		"-"+IMMEDIATE_SWITCH[0]+" to start backup without user interaction\n"+
		"-"+LONGHELP_SWITCH[0]+" for a longer help text\n"+
		"-"+NOCONFFILE_SWITCH[0]+" to force ignoring the default config file\n"+
		"-"+NOGUI_SWITCH[0]+" to start backup without GUI nor user interaction\n"+
		"-"+SIZE_SWITCH[0]+" [the backup target size in megabytes]\n"+
		"-"+SOURCE_SWITCH[0]+" [the backup source directory]\n"+
		"-"+TYPE_SWITCH[0]+" [the backup type]\n"+
		"-"+VERSION_SWITCH[0]+" to display version information\n"+
		"-"+ZIP_SWITCH[0]+" [zip compression filter settings]\n";


}
