/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package ui;

import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.Document;

import backup.Util;

/**
 * static class for logging events to file, to log document and to System.out / System.err
 * 
 * @author  Georg Dietrich
 * @version 1.0 on 2004-04-20
 */
public class Log {
	
	// TODO: implement the log levels
	
	/** the document the applications log is kept in */
	public static Document log = new DefaultStyledDocument();
	
	/** writer for the log file */
	protected static FileWriter writer = new FileWriter (Util.logPath());

	/** print to log, log file and to stdout */
	public static void println (String string) {
		// stdout
		System.out.println(string);
		// logfile
		writer.println(string);
		// log
		try {
			log.insertString(log.getLength(), string+"\n", null);
		} catch (Exception e) {
			System.out.println("Error in logging mechanism while logging "+string);
			e.printStackTrace();
		}
	}

	/** print to log and to stdout, not to log file to avoid recursion */
	public static void printlnNoFile (String string) {
		// stdout
		System.out.println("* "+string);
		// log
		try {
			log.insertString(log.getLength(), "* "+string+"\n", null);
		} catch (Exception e) {
			System.out.println("* Error in logging mechanism while logging "+string);
			e.printStackTrace();
		}
	}

}
