/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package ui;

import java.util.Vector;

import javax.swing.JComponent;

import backup.ObjectHandler;

/**
 * @author Georg Dietrich
 *
 * @version 2.1 on 15.05.2004
 * @version 2.0 on    05.2004
 * @version 1.0 on 25.04.2004
 */
public class StringContainer {

	// TODO: documentation

	protected String string = "";
	protected Vector listeners = new Vector();
	
	public void addListener (ObjectHandler handler) {
		if (!listeners.contains(handler)) listeners.add(handler);
	}

	public boolean removeListener (ObjectHandler handler) {
		return listeners.remove(handler);
	}
	
	public int length() {
		return string.length();
	}
	
	public StringContainer () {}
	public StringContainer (String newString) {
		setString(newString);
	}
		
	/**
	 * @return
	 */
	public String getString() {
		return string;
	}

	/**
	 * @return
	 */
	public String toString() {
		return string;
	}

	/**
	 * @param string
	 */
	public void setString(String string) {
		this.string = string;
		for (int i=0; i<listeners.size(); i++) ((ObjectHandler)listeners.get(i)).perform(this);
	}

	/**
	 * @param string
	 */
	public void setStringNoEvent(String string) {
		this.string = string;
	}
	
	public boolean equals (Object object) {
		return string == object.toString();
	}

	/**
	 * this method is used only by the "dissableRunning" StringContainer.  It registers a
	 * JComponent for enabling/disabling.
	 * 
	 * @param component  the component to register for the en/disable method
	 * @return           the component
	 */	
	public JComponent addComponent (final JComponent component) {
		addListener(new ObjectHandler () {
			public boolean perform(Object object) {
				component.setEnabled(string.equals("enabled"));
				return false;
			}
		});
		return component;
	}
}
