/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package ui;

import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import backup.ObjectHandler;

/**
 * @author  Georg Dietrich
 * @version 1.0 on 23.04.2004
 */
public class TextField extends JTextField implements DocumentListener, ObjectHandler {
	
	StringContainer myValue;
	
	public TextField (StringContainer value) {
		super (value.toString());
		myValue = value;
		this.getDocument().addDocumentListener(this);
		value.addListener(this);
	}

	/**
	 * these Document Listener events update the value of the associated StringBuffer.
	 */
	public void changedUpdate(DocumentEvent arg0) {
		myValue.setStringNoEvent(getText());
		GuiSettings.changed();
	}

	/**
	 * these Document Listener events update the value of the associated StringBuffer.
	 */
	public void insertUpdate(DocumentEvent arg0) {
		myValue.setStringNoEvent(getText());
		GuiSettings.changed();
	}

	/**
	 * these Document Listener events update the value of the associated StringBuffer.
	 */
	public void removeUpdate(DocumentEvent arg0) {
		myValue.setStringNoEvent(getText());
		GuiSettings.changed();
	}

	/* (Kein Javadoc)
	 * @see backup.ObjectHandler#perform(java.lang.Object)
	 */
	public boolean perform(Object object) {
		setText(object.toString());
		GuiSettings.changed();
		return true;
	}
}
