/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.JComboBox;

import backup.Util;

/**
 * TypeChooser is the JComboBox dropdown chooser with
 * predefined text entries.
 * 
 * @author Georg Dietrich
 * @version 1.1 on 2004-05-05
 * @version 1.0 on 2004-04-25
 */
class TypeChooser extends JComboBox {
	final StringContainer option;
	TypeChooser (String[] types, StringContainer type) {
		super(types);
		setSelectedIndex(Util.parseInt(type));
		option = type;
		ActionListener listener = new AbstractAction () {
			public void actionPerformed(ActionEvent arg0) {
				option.setString(String.valueOf(getSelectedIndex()));
				GuiSettings.changed();
			}
		};
		addActionListener(listener);
	}
	/* (Kein Javadoc)
	 * @see backup.ObjectHandler#perform(java.lang.Object)
	 */
	public boolean perform(Object object) {
		setSelectedIndex(Util.parseInt(option));
		GuiSettings.changed();
		return true;
	}
}


